FFmpeg Ubuntu 20.04 编译

FFmpeg 编译最佳的做法当然是参考官方文档,官方文档的指导最权威可行了。但还是需要一点小技巧才行。

编译环境:Ubuntu 20.04

官方文档指出安装是非侵入性的,将在主目录(home)中创建几个目录:

ffmpeg_sources——源文件将在这里下载。如果需要,可以在完成编译时删除。

ffmpeg_build——在这里构建文件并安装库。如果需要,可以在完成编译时删除。

bin——在这里安装二进制文件(ffmpeg, ffplay, ffprobe, x264, x265)。

一、获取编译前的依赖项

如果采用更换服务器地址的方法,自动选择最佳服务器,依赖包下载不了,第一步就被卡壳了。

1.进入 软件和更新(Applications -> Software & Updates);

2.Ubuntu 软件(Ubuntu Software) -> 下载自:(Download from),点击下载自列表框选择其他站点…(Others…);

3.点击右侧选择最佳服务器(S)(Select Best Server);

4.进入测试下载服务器页面(Testing download servers);

5.等待上一步测试下载服务器结束后,点击右下角选择服务器(S)(Choose Server);

6.更换服务器需要输入密码;

7.点击右下角关闭(Close);

8.弹出可能的软件列表已过时,点击重新载入(Reload)。

只需手动选择国内阿里云的服务器地址(China -> mirrors.aliyun.com -> Choose Server)即可,如果第一次没用成功更新所有的包,继续运行下面的命令,只到所有的依赖下载完成,我执行了两遍命令才下载好。
在这里插入图片描述

sudo apt-get update -qq && sudo apt-get -y install \
  autoconf \
  automake \
  build-essential \
  cmake \
  git-core \
  libass-dev \
  libfreetype6-dev \
  libgnutls28-dev \
  libsdl2-dev \
  libtool \
  libva-dev \
  libvdpau-dev \
  libvorbis-dev \
  libxcb1-dev \
  libxcb-shm0-dev \
  libxcb-xfixes0-dev \
  meson \
  ninja-build \
  pkg-config \
  texinfo \
  wget \
  yasm \
  zlib1g-dev

有包没有下载下来。
在这里插入图片描述
继续执行上面的命令只到全部依赖包下载完成。
在这里插入图片描述
备注:服务器用户可以忽略 ffplay 和 x11grab 依赖项:libsdl2-dev libva-dev libvdpau-dev libxcb1-dev libxcb-shm0-dev libxcb-xfixes0-dev

在主目录中创建一个新目录来存放所有的源代码和二进制文件:

mkdir -p ~/ffmpeg_sources ~/bin

在这里插入图片描述

二、安装 FFmpeg 编译时需要第三方库

如果要安装一些最常见的第三方库。每一节都提供了安装该库所需的命令。对于每个部分,将整个代码块复制粘贴到 shell 中。

如果不需要某些特性,可以跳过相关的部分(如果不需要的话),然后删除 FFmpeg 中适当的 ./configure 选项。例如,如果不需要 libvpx,跳过该部分,然后从安装 FFmpeg 部分删除 --enable-libvpx。

为了体验 FFmpeg 所有的功能,所以安装全部这些库。

NASM

一些库使用的汇编程序。

注意版本要 ≥ 2.13。此处我的安装版本是 2.14.02-1。

sudo apt-get install nasm

在这里插入图片描述
如果安装的版本低于 2.13,那就需要手动下载源码编译安装了。

cd ~/ffmpeg_sources && \
wget https://www.nasm.us/pub/nasm/releasebuilds/2.15.05/nasm-2.15.05.tar.bz2 && \
tar xjvf nasm-2.15.05.tar.bz2 && \
cd nasm-2.15.05 && \
./autogen.sh && \
PATH="$HOME/bin:$PATH" ./configure --prefix="$HOME/ffmpeg_build" --bindir="$HOME/bin" && \
make && \
make install

其他的第三方库安装也是类似的。

libx264

H.264 视频编码器。版本要 ≥ 118。

需要 ffmpeg 编译选项配置 --enable-gpl 和 --enable-libx264。

sudo apt-get install libx264-dev

libx265

H.265/HEVC 视频编码器。版本 ≥ 68。

需要 ffmpeg 编译选项配置 --enable-gpl 和 --enable-libx265。

sudo apt-get install libx265-dev libnuma-dev

libvpx

VP8/VP9 视频编码、解码器。版本 ≥ 1.4.0。

需要 ffmpeg 编译选项配置 --enable-libvpx。

sudo apt-get install libvpx-dev

libfdk-aac

AAC 音频编码器。

需要 ffmpeg 编译选项配置 --enable-libfdk-aac(如果配置包含了 --enable-gpl 需要同时添加 --enable-nonfree)。

sudo apt-get install libfdk-aac-dev

libmp3lame

mp3 音频编码器。版本 ≥ 3.98.3。

需要 ffmpeg 编译选项配置 --enable-libmp3lame。

sudo apt-get install libmp3lame-dev

libopus

Opus音频解码器和编码器。版本 ≥ 1.1。

需要 ffmpeg 编译选项配置 --enable-libopus。

sudo apt-get install libopus-dev

libsvtav1

AV1 视频解码器和编码器。FFmpeg 只支持编码器,因此编译不支持解码器。

需要 ffmpeg 编译选项配置 --enable-libsvtav1。

cd ~/ffmpeg_sources && \
git -C SVT-AV1 pull 2> /dev/null || git clone https://gitlab.com/AOMediaCodec/SVT-AV1.git && \
mkdir -p SVT-AV1/build && \
cd SVT-AV1/build && \
PATH="$HOME/bin:$PATH" cmake -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX="$HOME/ffmpeg_build" -DCMAKE_BUILD_TYPE=Release -DBUILD_DEC=OFF -DBUILD_SHARED_LIBS=OFF .. && \
PATH="$HOME/bin:$PATH" make && \
make install

libdav1d

AV1 解码器,比libaom 快得多。

需要 ffmpeg 编译选项配置 --enable-libdav1d。

sudo apt-get install libdav1d-dev

在这里插入图片描述
没有这个安装包,只能手动下载源码,编译安装了。如果 Linux 发行版没有提供足够最新的 meson 版本(0.49.0 或更新的),需要安装更最新的版本。这很容易通过 Python 包索引完成:

sudo apt-get install python3-pip && \
pip3 install --user meson

查看 meson 可知,版本是 0.53.2,不需要更新了。
在这里插入图片描述
AVX-512 支持需要 NASM 版本 ≥ 2.14。我安装的版本是 2.14.02-1,满足条件。或者使用 -Denable_avx512=false 禁用 meson 设置中的 AVX-512。

cd ~/ffmpeg_sources && \
git -C dav1d pull 2> /dev/null || git clone --depth 1 https://code.videolan.org/videolan/dav1d.git && \
mkdir -p dav1d/build && \
cd dav1d/build && \
meson setup -Denable_tools=false -Denable_tests=false --default-library=static .. --prefix "$HOME/ffmpeg_build" --libdir="$HOME/ffmpeg_build/lib" && \
ninja && \
ninja install

三、编译 FFmpeg

cd ~/ffmpeg_sources && \
wget -O ffmpeg-snapshot.tar.bz2 https://ffmpeg.org/releases/ffmpeg-snapshot.tar.bz2 && \
tar xjvf ffmpeg-snapshot.tar.bz2 && \
cd ffmpeg && \
PATH="$HOME/bin:$PATH" PKG_CONFIG_PATH="$HOME/ffmpeg_build/lib/pkgconfig" ./configure \
  --prefix="$HOME/ffmpeg_build" \
  --pkg-config-flags="--static" \
  --extra-cflags="-I$HOME/ffmpeg_build/include" \
  --extra-ldflags="-L$HOME/ffmpeg_build/lib" \
  --extra-libs="-lpthread -lm" \
  --ld="g++" \
  --bindir="$HOME/bin" \
  --enable-gpl \
  --enable-gnutls \
  --enable-libass \
  --enable-libfdk-aac \
  --enable-libfreetype \
  --enable-libmp3lame \
  --enable-libopus \
  --enable-libsvtav1 \
  --enable-libdav1d \
  --enable-libvorbis \
  --enable-libvpx \
  --enable-libx264 \
  --enable-libx265 \
  --enable-nonfree && \
PATH="$HOME/bin:$PATH" make && \
make install && \
hash -r

兴高采烈的开始 FFmpeg 编译,编译突然报错了:ERROR: gnutls not found using pkg-config

检查获取编译前的依赖项,libgnutls28-dev 已经安装了,版本是 3.6.13-2。赶紧网络上搜索一番,有人说从 Ubuntu16.04 开始,编译 ffmpeg 就报这个错。
在这里插入图片描述
解决方案是安装 libunistring-dev。

sudo apt-get install libunistring-dev

再次编译 FFmpeg,这次就编译成功了!

现在重新登录或为当前 shell 会话运行以下命令来识别新的 ffmpeg 位置(使环境变量生效):

source ~/.profile

编译和安装现在已经完成,ffmpeg(还有ffplay、ffprobe、lame、x264和x265)现在应该可以使用了。

四、用法

现在可以打开一个终端,输入 ffmpeg 命令,它应该会执行新的 ffmpeg。
在这里插入图片描述
如果需要同一个系统上的多个用户访问新 ffmpeg,而不仅仅是编译它的用户,那么将 ffmpeg 二进制文件从 ~/bin 移动或复制到 /usr/local/bin 即可。

五、更新 FFmpeg

FFmpeg 的开发是活跃的,偶尔的更新可以提供新特性和 bug 修复。首先,需要删除(或移动)旧文件:

rm -rf ~/ffmpeg_build ~/bin/{ffmpeg,ffprobe,ffplay,x264,x265}

再次按照编译流程开始一遍即可。

六、还原编译 FFmpeg 所做的更改

删除编译文件、源文件以及二进制文件:

rm -rf ~/ffmpeg_build ~/ffmpeg_sources ~/bin/{ffmpeg,ffprobe,ffplay,x264,x265,nasm}
sed -i '/ffmpeg_build/d' ~/.manpath
hash -r

也可以删除编译 FFmpeg 中已经安装的软件包:

sudo apt-get autoremove autoconf automake build-essential cmake git-core libass-dev libfreetype6-dev libgnutls28-dev libmp3lame-dev libnuma-dev libopus-dev libsdl2-dev libtool libva-dev libvdpau-dev libvorbis-dev libvpx-dev libx264-dev libx265-dev libxcb1-dev libxcb-shm0-dev ibxcb-xfixes0-dev texinfo wget yasm zlib1g-dev

参考资料:

1.https://trac.ffmpeg.org/wiki/CompilationGuide/Ubuntu

2.https://blog.csdn.net/amu1550/article/details/109648576

tyyj90 CSDN认证博客专家 安卓全栈开发
Android高级开发工程师,熟悉App开发,熟悉Framework定制开发,略了解Linux内核。开发使用的语言涉及Java、Kotlin、C/C++、Python和汇编NEON指令集。
相关推荐
©️2020 CSDN 皮肤主题: 像素格子 设计师:CSDN官方博客 返回首页
实付 9.90元
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值